from datetime import date
from pyramid.httpexceptions import HTTPFound
from pyramid.view import view_config
from ringo.lib.helpers import (
    get_action_routename
)
from ringo.views.base import update
from ringo.views.helpers import get_item_from_request
from waskiq.model.angebot import Angebot


@view_config(route_name=get_action_routename(Angebot, 'update'),
             renderer='/default/update.mako',
             permission='update')
def update_(request):
    item = get_item_from_request(request)
    participation = item.baustein_cm.participation

    # We want to render fp1 participations as readonly, if the option
    # efa.fp2_readonly is set.
    check_render_fp1_ro = request.registry.settings.get(
        "efa.participations_fp1_readonly") == "true"

    # We want to bend fp1 participations to readonly.
    check_start_date = (participation.start_date and
                        participation.start_date < date(2019, 1, 1))
    if check_render_fp1_ro and check_start_date:
        return HTTPFound(request.route_path(get_action_routename(
            Angebot, 'read'), id=item.id))

    return update(request)
